OpenJPH: /build/openjph/src/OpenJPH/src/apps/ojph_compress/ojph_compress.cpp File Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph_compress.cpp File Reference
`#include <ctime>`
`#include <iostream>`
`#include "ojph_arg.h"`
`#include "ojph_mem.h"`
`#include "ojph_img_io.h"`
`#include "ojph_file.h"`
`#include "ojph_codestream.h"`
`#include "ojph_params.h"`
`#include "ojph_message.h"`

Go to the source code of this file.

## Classes
struct | size_list_interpreter
struct | point_list_interpreter
struct | size_interpreter
struct | point_interpreter
struct | ui32_list_interpreter
struct | si32_to_bool_list_interpreter
struct | tileparts_division_interpreter

## Functions
static bool | get_arguments (int argc, char *argv[], char *&input_filename, char *&output_filename, char *&progression_order, char *&profile_string, ojph::ui32 &num_decompositions, float &quantization_step, int &qfactor, bool &reversible, int &employ_color_transform, const int max_num_precincts, int &num_precincts, ojph::size *precinct_size, ojph::size &block_size, ojph::size &dims, ojph::point &image_offset, ojph::size &tile_size, ojph::point &tile_offset, ojph::ui32 &max_num_comps, ojph::ui32 &num_comps, ojph::ui32 &num_comp_downsamps, ojph::point *&comp_downsamp, ojph::ui32 &num_bit_depths, ojph::ui32 *&bit_depth, ojph::ui32 &num_is_signed, ojph::si32 *&is_signed, bool &tlm_marker, bool &tileparts_at_resolutions, bool &tileparts_at_components, char *&com_string)
static const char * | get_file_extension (const char *filename)
static bool | is_matching (const char *ref, const char *other)
int | main (int argc, char *argv[])

## Function Documentation

## ◆ get_arguments()

bool get_arguments | ( | int | argc,
|  | char * | argv[],
|  | char *& | input_filename,
|  | char *& | output_filename,
|  | char *& | progression_order,
|  | char *& | profile_string,
|  | ojph::ui32 & | num_decompositions,
|  | float & | quantization_step,
|  | int & | qfactor,
|  | bool & | reversible,
|  | int & | employ_color_transform,
|  | const int | max_num_precincts,
|  | int & | num_precincts,
|  | ojph::size * | precinct_size,
|  | ojph::size & | block_size,
|  | ojph::size & | dims,
|  | ojph::point & | image_offset,
|  | ojph::size & | tile_size,
|  | ojph::point & | tile_offset,
|  | ojph::ui32 & | max_num_comps,
|  | ojph::ui32 & | num_comps,
|  | ojph::ui32 & | num_comp_downsamps,
|  | ojph::point *& | comp_downsamp,
|  | ojph::ui32 & | num_bit_depths,
|  | ojph::ui32 *& | bit_depth,
|  | ojph::ui32 & | num_is_signed,
|  | ojph::si32 *& | is_signed,
|  | bool & | tlm_marker,
|  | bool & | tileparts_at_resolutions,
|  | bool & | tileparts_at_components,
|  | char *& | com_string )
| static

Definition at line 361 of file ojph_compress.cpp.

References ojph::argument::arg, ojph::cli_interpreter::get_argument_zero(), ojph::cli_interpreter::get_next_avail_argument(), ojph::cli_interpreter::init(), ojph::cli_interpreter::is_exhausted(), ojph::argument::is_valid(), ojph::cli_interpreter::reinterpret(), and ojph::cli_interpreter::reinterpret_to_bool().

Referenced by main().

## ◆ get_file_extension()

const char * get_file_extension | ( | const char * | filename | ) |
| static

Definition at line 461 of file ojph_compress.cpp.

References OJPH_ERROR.

Referenced by main().

## ◆ is_matching()

bool is_matching | ( | const char * | ref,
|  | const char * | other )
| static

Definition at line 474 of file ojph_compress.cpp.

Referenced by main().

## ◆ main()

int main | ( | int | argc,
|  | char * | argv[] )

Definition at line 492 of file ojph_compress.cpp.

References ojph::codestream::access_cod(), ojph::codestream::access_nlt(), ojph::codestream::access_qcd(), ojph::codestream::access_siz(), ojph::param_nlt::ALL_COMPS, ojph::codestream::close(), ojph::image_in_base::close(), ojph::pfm_in::configure(), ojph::codestream::exchange(), ojph::codestream::flush(), get_arguments(), ojph::dpx_in::get_bit_depth(), ojph::ppm_in::get_bit_depth(), ojph::dpx_in::get_comp_subsampling(), ojph::ppm_in::get_comp_subsampling(), ojph::param_siz::get_downsampling(), get_file_extension(), ojph::pfm_in::get_height(), ojph::ppm_in::get_height(), ojph::param_siz::get_image_extent(), ojph::param_siz::get_image_offset(), ojph::dpx_in::get_is_signed(), ojph::ppm_in::get_is_signed(), ojph::dpx_in::get_num_components(), ojph::param_siz::get_num_components(), ojph::pfm_in::get_num_components(), ojph::ppm_in::get_num_components(), ojph::dpx_in::get_size(), ojph::pfm_in::get_width(), ojph::ppm_in::get_width(), ojph::size::h, is_matching(), ojph::codestream::is_planar(), ojph_div_ceil, OJPH_ERROR, ojph_max, ojph::param_nlt::OJPH_NLT_BINARY_COMPLEMENT_NLT, OJPH_WARN, ojph::dpx_in::open(), ojph::j2c_outfile::open(), ojph::pfm_in::open(), ojph::ppm_in::open(), ojph::raw_in::open(), ojph::yuv_in::open(), ojph::image_in_base::read(), ojph::codestream::request_tlm_marker(), ojph::yuv_in::set_bit_depth(), ojph::param_cod::set_block_dims(), ojph::param_cod::set_color_transform(), ojph::param_siz::set_component(), ojph::param_siz::set_image_extent(), ojph::param_siz::set_image_offset(), ojph::raw_in::set_img_props(), ojph::yuv_in::set_img_props(), ojph::param_qcd::set_irrev_quant(), ojph::param_nlt::set_nonlinear_transform(), ojph::param_siz::set_num_components(), ojph::param_cod::set_num_decomposition(), ojph::codestream::set_planar(), ojph::param_cod::set_precinct_size(), ojph::codestream::set_profile(), ojph::param_cod::set_progression_order(), ojph::param_qcd::set_qfactor(), ojph::param_cod::set_reversible(), ojph::comment_exchange::set_string(), ojph::param_siz::set_tile_offset(), ojph::param_siz::set_tile_size(), ojph::codestream::set_tilepart_divisions(), ojph::size::w, ojph::codestream::write_headers(), ojph::point::x, and ojph::point::y.

Referenced by ojph::local::param_qcd::propose_precision().